*$ CREATE MGDRAW.FOR
*COPY MGDRAW
*                                                                      *
*=== mgdraw ===========================================================*
*                                                                      *
      SUBROUTINE MGDRAW ( ICODE, MREG )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1990-2006      by        Alfredo Ferrari           *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     MaGnetic field trajectory DRAWing: actually this entry manages   *
*                                        all trajectory dumping for    *
*                                        drawing                       *
*                                                                      *
*     Created on   01 march 1990   by        Alfredo Ferrari           *
*                                              INFN - Milan            *
*     Last change  05-may-06       by        Alfredo Ferrari           *
*                                              INFN - Milan            *
*                                                                      *
*----------------------------------------------------------------------*
*
      INCLUDE '(CASLIM)'
      INCLUDE '(COMPUT)'
      INCLUDE '(SOURCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(GENSTK)'
      INCLUDE '(MGDDCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(QUEMGD)'
      INCLUDE '(SUMCOU)'
      INCLUDE '(TRACKR)'
      INCLUDE '(GOMLOC)'
*
      include 'lnsnt.inc'
*
      DIMENSION DTQUEN ( MXTRCK, MAXQMG )
*
      CHARACTER*20 FILNAM
      LOGICAL LFCOPE
      SAVE LFCOPE
      DATA LFCOPE / .FALSE. /

      real*4 ytup(10)

c      common /mycom/ mmreg, nnewreg
*
*----------------------------------------------------------------------*
*                                                                      *
*     Icode = 1: call from Kaskad                                      *
*     Icode = 2: call from Emfsco                                      *
*     Icode = 3: call from Kasneu                                      *
*     Icode = 4: call from Kashea                                      *
*     Icode = 5: call from Kasoph                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'UNFORMATTED' )
      END IF

c      write(61,*) ntrack, mtrack, jtrack, sngl(etrack), sngl(wtrack)
c      write(60,*) (i,sngl(xtrack(i)), sngl(ytrack(i)), sngl(ztrack(i)),
c     &             i=0, ntrack)
c      write(63,*) (sngl(dtrack(i)), i=1, mtrack), sngl(ctrack)
c      write(64,*) (sngl(ttrack(i)), i=1, ntrack)
c      write(62,*) ztrack(1),KMA ,KFPD ,KLCR,KNBD , KIOR , KRIZ , KRCZ ,
c     &                KMIZ , KMCZ , KKR1 , KKR2 , KRDN , KNSR , KVOL ,
c     &                KRNM , NAAD , LDATA, LTMA , LFPD , NUMR , IRTRU,
c     &                NUMB , NIR
      write(61,*) sngl(xtrack(1)),sngl(ytrack(1)),sngl(ztrack(1)),
     &     sngl(etrack),am(jtrack)
c      write(62,*) sngl(ztrack(1)),ztrack(1)

*     inside kapton
      if(sngl(ztrack(1)).eq.real(5.0))then
         xikap=sngl(xtrack(1))
         yikap=sngl(ytrack(1))
         zikap=sngl(ztrack(1))
         eikap=sngl(etrack)-am(jtrack)
         elseif(sngl(ztrack(1)).gt.real(5.000).and.
     $          sngl(ztrack(1)).le.real(5.005))then
         xfkap=sngl(xtrack(1))
         yfkap=sngl(ytrack(1))
         zfkap=sngl(ztrack(1))
         efkap=sngl(etrack)-am(jtrack)
      endif

*     inside scintillator
      if(sngl(ztrack(1)).eq.real(10.005))then
         xisci=sngl(xtrack(1))
         yisci=sngl(ytrack(1))
         zisci=sngl(ztrack(1))
         eisci=sngl(etrack)-am(jtrack)
         elseif(sngl(ztrack(1)).gt.real(10.005).and.
     $          sngl(ztrack(1)).le.real(10.008))then
         xfsci=sngl(xtrack(1))
         yfsci=sngl(ytrack(1))
         zfsci=sngl(ztrack(1))
         efsci=sngl(etrack)-am(jtrack)
      endif

*     inside silicon
      if(sngl(ztrack(1)).eq.real(19.008))then
         xisil=sngl(xtrack(1))
         yisil=sngl(ytrack(1))
         zisil=sngl(ztrack(1))
         eisil=sngl(etrack)-am(jtrack)
         elseif(sngl(ztrack(1)).gt.real(19.008).and.
     $          sngl(ztrack(1)).le.real(19.108).and.
     $          etrack.eq.am(jtrack))then
         xfsil=sngl(xtrack(1))
         yfsil=sngl(ytrack(1))
         zfsil=sngl(ztrack(1))
         efsil=sngl(etrack)-am(jtrack)
*        when particle passed silicon
         else
         xf=sngl(xtrack(1))
         yf=sngl(ytrack(1))
         zf=sngl(ztrack(1))
         ef=sngl(etrack)
      endif


c      WRITE (IODRAW) NTRACK, MTRACK, JTRACK, SNGL (ETRACK),
c     &               SNGL (WTRACK)
c      WRITE (IODRAW) ( SNGL (XTRACK (I)) , SNGL (YTRACK (I)), 
c     &                 SNGL (ZTRACK (I)), I = 0, NTRACK ),
c     &               ( SNGL (DTRACK (I)), I = 1, MTRACK ),
c     &                 SNGL (CTRACK)

*  +-------------------------------------------------------------------*
*  |  Quenching is activated
      IF ( LQEMGD ) THEN
         RULLL = ZERZER
         CALL QUENMG ( ICODE, MREG, RULLL, DTQUEN )
C         WRITE (IODRAW) ( ( SNGL (DTQUEN (I,JBK)), I = 1, MTRACK ),
C     &                      JBK = 1, NQEMGD )
      END IF
*  |  End of quenching

*     check that ??!?!

c      WRITE (IODRAW) NTRACK, MTRACK, JTRACK, SNGL (ETRACK),
c     &               SNGL (WTRACK)
c      WRITE (IODRAW) ( SNGL (XTRACK (I)) , SNGL (YTRACK (I)), 
c     &                 SNGL (ZTRACK (I)), I = 0, NTRACK ),
c     &               ( SNGL (DTRACK (I)), I = 1, MTRACK ),
c     &                 SNGL (CTRACK)

C         WRITE (IODRAW) ( ( SNGL (DTQUEN (I,JBK)), I = 1, MTRACK ),
C     &                      JBK = 1, NQEMGD )

*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     Boundary-(X)crossing DRAWing:                                    *
*                                                                      *
*     Icode = 1x: call from Kaskad                                     *
*             19: boundary crossing                                    *
*     Icode = 2x: call from Emfsco                                     *
*             29: boundary crossing                                    *
*     Icode = 3x: call from Kasneu                                     *
*             39: boundary crossing                                    *
*     Icode = 4x: call from Kashea                                     *
*             49: boundary crossing                                    *
*     Icode = 5x: call from Kasoph                                     *
*             59: boundary crossing                                    *
*                                                                      *
*======================================================================*
*                                                                      *
*     Jtrack         = identity number of the particle                 *
*     Etrack         = total energy of the particle                    *
*     Am             = mass energy of the particle                     *
*     Cx,y,ztrck     = direction cosines of the current particle       *
*     Mreg           = region number before the boundary crossing      *
*     Newreg         = region number after the boundary crossing       *
*     xco,yco,zco    = coordinates of the particle at boundary crossing*

      ENTRY BXDRAW ( ICODE, MREG, NEWREG, XSCO, YSCO, ZSCO )
      
c      write(70,*) 'BXDRAW ',icode,mreg,newreg,jtrack,etrack,am(jtrack)

c      mmreg=mreg
c      nnewreg=newreg

*     select crossing for each boundaries
      if((mreg.eq.3.and.newreg.eq.4).or.
     $   (mreg.eq.4.and.newreg.eq.2).or.
     $   (mreg.eq.2.and.newreg.eq.5).or.
     $   (mreg.eq.5.and.newreg.eq.2).or.
     $   (mreg.eq.2.and.newreg.eq.6).or.
     $   (mreg.eq.6.and.newreg.eq.2))then
 	 if(jtrack.eq.-2) then               ! select HeavyIon
            if(etrack.gt.am(jtrack))then     ! HeavyIon has survived
c               pmom=sqrt(etrack**2-am(jtrack)**2)
c               acon=pmom/am(jtrack)
c               bet2=acon**2/(1+acon**2)
c               ekbz=0.5*am(jtrack)*bet2
               ytup(1) = jtrack
               ytup(2) = etrack
               ytup(3) = etrack-am(jtrack)
               ytup(4) = xsco
               ytup(5) = ysco
               ytup(6) = zsco
               ytup(7) = cxtrck
               ytup(8)= cytrck
               ytup(9)= cztrck
               ytup(10)= mreg-newreg 
               call hfn(120,ytup)
c               bdx_pmom = etrack
c               bdx_ekin = etrack-am(jtrack)
c               bdx_xsco = xsco
c               bdx_ysco = ysco
c               bdx_zsco = zsco
c               bdx_cxtr = cxtrck
c               bdx_cytr = cytrck
c               bdx_cztr = cztrck
c               bdx_crss = mreg-newreg
c               call hfnt(13)
            endif
	 endif
      endif

      RETURN
*
*
*======================================================================*
*                                                                      *
*     Event End DRAWing:                                               *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY EEDRAW ( ICODE )

      RETURN
*
*======================================================================*
*                                                                      *
*     ENergy deposition DRAWing:                                       *
*                                                                      *
*     Icode = 1x: call from Kaskad                                     *
*             10: elastic interaction recoil                           *
*             11: inelastic interaction recoil                         *
*             12: stopping particle                                    *
*             13: pseudo-neutron deposition                            *
*             14: escape                                               *
*             15: time kill                                            *
*     Icode = 2x: call from Emfsco                                     *
*             20: local energy deposition (i.e. photoelectric)         *
*             21: below threshold, iarg=1                              *
*             22: below threshold, iarg=2                              *
*             23: escape                                               *
*             24: time kill                                            *
*     Icode = 3x: call from Kasneu                                     *
*             30: target recoil                                        *
*             31: below threshold                                      *
*             32: escape                                               *
*             33: time kill                                            *
*     Icode = 4x: call from Kashea                                     *
*             40: escape                                               *
*             41: time kill                                            *
*             42: delta ray stack overflow                             *
*     Icode = 5x: call from Kasoph                                     *
*             50: optical photon absorption                            *
*             51: escape                                               *
*             52: time kill                                            *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY ENDRAW ( ICODE, MREG, RULL, XSCO, YSCO, ZSCO )
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'UNFORMATTED' )
      END IF
C      WRITE (IODRAW)  0, ICODE, JTRACK, SNGL (ETRACK), SNGL (WTRACK)
C      WRITE (IODRAW)  SNGL (XSCO), SNGL (YSCO), SNGL (ZSCO), SNGL (RULL)
*  +-------------------------------------------------------------------*
*  |  Quenching is activated : calculate quenching factor
*  |  and store quenched energy in DTQUEN(1, jbk)
      IF ( LQEMGD ) THEN
         RULLL = RULL
         CALL QUENMG ( ICODE, MREG, RULLL, DTQUEN )
C         WRITE (IODRAW) ( SNGL (DTQUEN(1, JBK)), JBK = 1, NQEMGD )
      END IF
*  |  end quenching
*  +-------------------------------------------------------------------*
c      write(37,*) jtrack,etrack,am(jtrack),wtrack,xsco,
c     $              ysco,zsco,mreg,rull,icode

c      if(mreg.eq.5)then
c       if(jtrack.eq.-2)then
c        lnsTUP2(1) = jtrack
c        lnsTUP2(2) = etrack*1e3
c        lnsTUP2(3) = (etrack-am(jtrack))*1e3
c        lnsTUP2(4) = wtrack
c        lnsTUP2(5) = xsco
c        lnsTUP2(6) = ysco
c        lnsTUP2(7) = zsco
c        lnsTUP2(8) = mreg
c        lnsTUP2(9) = rull
c        call hfn(12,lnsTUP2)
c       endif
c      endif

      RETURN
*
*======================================================================*
*                                                                      *
*     SOurce particle DRAWing:                                         *
*                                                                      *
*======================================================================*
*
      ENTRY SODRAW
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'UNFORMATTED' )
      END IF
C      WRITE (IODRAW) -NCASE, NPFLKA, NSTMAX, SNGL (TKESUM),
C     &                SNGL (WEIPRI)
*  +-------------------------------------------------------------------*
*  |  (Radioactive) isotope: it works only for 1 source particle on
*  |  the stack for the time being
      IF ( ILOFLK (NPFLKA) .GE. 100000 .AND. LRADDC (NPFLKA) ) THEN
         IARES  = MOD ( ILOFLK (NPFLKA), 100000  )  / 100
         IZRES  = MOD ( ILOFLK (NPFLKA), 10000000 ) / 100000
         IISRES = ILOFLK (NPFLKA) / 10000000
         IONID  = ILOFLK (NPFLKA)
C         WRITE (IODRAW) ( IONID,SNGL(-TKEFLK(I)),
C     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
C     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
C     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
C     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
*  |
*  +-------------------------------------------------------------------*
*  |  Patch for heavy ions: it works only for 1 source particle on
*  |  the stack for the time being
      ELSE IF ( ABS (ILOFLK (NPFLKA)) .GE. 10000 ) THEN
         IONID = ILOFLK (NPFLKA)
         CALL DCDION ( IONID )
C         WRITE (IODRAW) ( IONID,SNGL(TKEFLK(I)+AMNHEA(-IONID)),
C     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
C     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
C     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
C     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
*  |
*  +-------------------------------------------------------------------*
*  |  Patch for heavy ions: ???
      ELSE IF ( ILOFLK (NPFLKA) .LT. -6 ) THEN
C         WRITE (IODRAW) ( IONID,SNGL(TKEFLK(I)+AMNHEA(-ILOFLK(NPFLKA))),
C     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
C     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
C     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
C     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
*  |
*  +-------------------------------------------------------------------*
*  |
      ELSE
C         WRITE (IODRAW) ( ILOFLK(I), SNGL (TKEFLK(I)+AM(ILOFLK(I))),
C     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
C     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
C     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
C     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
      END IF
*  |
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     USer dependent DRAWing:                                          *
*                                                                      *
*     Icode = 10x: call from Kaskad                                    *
*             100: elastic   interaction secondaries                   *
*             101: inelastic interaction secondaries                   *
*             102: particle decay  secondaries                         *
*             103: delta ray  generation secondaries                   *
*             104: pair production secondaries                         *
*             105: bremsstrahlung  secondaries                         *
*             110: decay products                                      *
*     Icode = 20x: call from Emfsco                                    *
*             208: bremsstrahlung secondaries                          *
*             210: Moller secondaries                                  *
*             212: Bhabha secondaries                                  *
*             214: in-flight annihilation secondaries                  *
*             215: annihilation at rest   secondaries                  *
*             217: pair production        secondaries                  *
*             219: Compton scattering     secondaries                  *
*             221: photoelectric          secondaries                  *
*             225: Rayleigh scattering    secondaries                  *
*     Icode = 30x: call from Kasneu                                    *
*             300: interaction secondaries                             *
*     Icode = 40x: call from Kashea                                    *
*             400: delta ray  generation secondaries                   *
*  For all interactions secondaries are put on GENSTK common (kp=1,np) *
*  but for KASHEA delta ray generation where only the secondary elec-  *
*  tron is present and stacked on FLKSTK common for kp=npflka          *
*                                                                      *
*======================================================================*
*
      ENTRY USDRAW ( ICODE, MREG, XSCO, YSCO, ZSCO )
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'UNFORMATTED' )
      END IF
* No output by default:

      write(80,*) 'calisyoonnuu'

      RETURN
*=== End of subrutine Mgdraw ==========================================*
      END

